Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.beans
Class AccessControlEntry

    java.lang.Object
      oracle.ifs.beans.LibraryObject
          oracle.ifs.beans.TieLibraryObject
              oracle.ifs.beans.SystemObject
                  oracle.ifs.beans.TieSystemObject
                      oracle.ifs.beans.AccessControlEntry

All Implemented Interfaces:
  IfsEventHandler, LibraryObjectInterface, SystemObjectInterface, Traceable

Direct Known Subclasses:
  TieAccessControlEntry

    public class AccessControlEntry

extends TieSystemObject

The `AccessControlEntry` (ACE) class represents an atomic unit of access control.

The basic parts of an ACE are:

- AccessControlList - the ACL that the ACE is part of
- Grantee - a grantee is the DirectoryObject (user or group) to which the privilege is to be granted or revoked.
- AccessLevel/PermissionBundle - represents the privilege being granted/revoked
- Granted - a boolean indicating if the privilege is being granted (true) or revoked (false)
- SortSequence - the order in which the access control will be resolved. Access is resolved in ascending order. For example, if the first ACE grants a group complete access to a PublicObject. Then the second ACE revokes specific privileges to distinct members of the group. The result would be some members having full privileges and others having restricted privileges. Had the order of the ACEs been reversed, the result would be the whole group having full privileges.

An ACE may be constructed either by using AccessLevel or PermissionBundles and can only exist in the context of referring to an AccessControlList.

See Also:
  `AccessControlList`, `AccessLevel`, `DirectoryObject`
(Published)

Field Summary
`static java.lang.String` | `ACCESSLEVEL_ATTRIBUTE` The level of the permission associated with this AccessControlEntry, e.g., Discover, Delete.
`static java.lang.String` | `ACL_ATTRIBUTE` The AccessControlList to which this AccessControlEntry belongs.
`static java.lang.String` | `CLASS_NAME` This class name for this class.
`static java.lang.String` | `EXTENDEDPERMISSIONS_ATTRIBUTE` The extended permission levels created by a custom application which are associated with this AccessControlEntry.
`static java.lang.String` | `GRANTED_ATTRIBUTE` An indicator of whether the AccessLevel is being granted or revoked by the AccessControlEntry.
`static java.lang.String` | `GRANTEE_ATTRIBUTE` The DirectoryObject to which this AccessControlEntry is applied.
`static java.lang.String` | `PERMISSIONBUNDLES_ATTRIBUTE` The PermissionBundles optionally used to set the permissions for this AccessControlEntry.
`static java.lang.String` | `SORTSEQUENCE_ATTRIBUTE` The sort sequence of this AccessControlEntry in the AccessControlList.

Fields inherited from class oracle.ifs.beans.SystemObject
`ACTIVE_ATTRIBUTE, POLICYBUNDLE_ATTRIBUTE, POLICYLISTS_ATTRIBUTE, PROPERTYBUNDLE_ATTRIBUTE`

Fields inherited from class oracle.ifs.beans.LibraryObject
`DOMAIN_UNIQUENAME_DEFAULT_DELIMITER, m_ClassId, m_Id, m_Session, NAME_ATTRIBUTE`

Constructor Summary
`protected` | `AccessControlEntry(LibrarySession session, java.lang.Long id, java.lang.Long classId, S_LibraryObjectData data)` Construct a AccessControlEntry object.

Method Summary
`protected static AccessControlEntry` | `constructAccessControlEntry(LibrarySession sess, S_LibraryObjectData data)` Construct AccessControlEntry from a S_LibraryObjectData
`protected static AccessControlEntry[]` | `constructAccessControlEntryArray(LibrarySession sess, java.lang.Long[] ids)` Construct a AccessControlEntry array from an array of object IDs.
`protected static java.util.Vector` | `constructAccessControlEntryVector(LibrarySession sess, java.util.Vector vector)` Construct a Vector of ACE from a Vector of S_LibraryObjectData.
`AccessControlList` | `getAcl()` Return the ACL object that contains this ACE.
`AccessLevel` | `getDistinctAccessLevel()` Returns the access level represented by this ACE without considering permission bundles.
`ExtendedPermission[]` | `getExtendedPermissions()` Returns extended permissions of this ACE.
`DirectoryObject` | `getGrantee()` Returns the directory object (grantee) that is associated with this ACE.
`AccessLevel` | `getMergedAccessLevel()` Returns the access level represented by this ACE including permission bundles.
`PermissionBundle[]` | `getPermissionBundles()` Returns all PermissionBundles that were used to define the set of permissions for this ACE.
`long` | `getSortSequence()` Returns the Sort Sequence represented by this ACE.
`boolean` | `isGrant()` Return indication as to whether this is a grant or a revoke ACE.
`protected static AccessControlEntry` | `vectorAccessControlEntryElement(java.util.Vector vector, int index)` Return a AccessControlEntry from a specified Vector of AccessControlEntrys and an index.
`protected static AccessControlEntry[]` | `vectorToAccessControlEntryArray(java.util.Vector vector)` Convert a Vector of AccessControlEntrys to an array of AccessControlEntrys.

Methods inherited from class oracle.ifs.beans.SystemObject
`addCategory, constructSystemObject, constructSystemObjectVector, free, freeCategories, getCategories, getCategories, getCategories, getCategories, getPolicyBundle, getPolicyLists, handleCreate, isActive, postCreate, postUpdate, preCreate, preUpdate, putPolicy, removeAllPolicies, removePolicy, removePolicy, setActive, setPolicyBundle, setPolicyLists`

Methods inherited from class oracle.ifs.beans.LibraryObject
`applyProperties, auditCreated, auditUpdated, checkRequiredAttributeSet, clearCopyContext, clearFreeContext, clearUpdateContext, constructIdArray, constructIdArray, constructLibraryObject, constructLibraryObjectVector, createDedicatedPropertyBundle, deriveDomainUniqueName, dispose, equals, free, get, getAttribute, getAttributeByUpperCaseName, getAttributes, getAttributesByUpperCaseNames, getAuditDomainContext, getAuditEventFolderContext, getClassId, getClassname, getClassName, getClassObject, getCommonName, getCopyContext, getCreateContext, getData, getDefinition, getEffectivePolicyListElements, getEventualAttributeByUpperCaseName, getFreeContext, getId, getLabel, getName, getObjectReferenceAttribute, getOperationActionSpecificationContext, getPropertyBundle, getPropertyValue, getPublicObjectAttribute, getResourceString, getResourceString, getSchemaObjectAttribute, getSession, getSessionInterface, getSharedStateFactory, getStringIdentifier, getSystemObjectAttribute, getTraceLogger, getUpdateContext, handleAdminModeChange, handleEvent, handleFree, handleUpdate, hashCode, hasNameAttribute, invokeOperation, invokeOperation, invokeServerMethod, isConnected, isCoreEventPostingEnabled, isInstanceOf, isTraced, isValidEventType, lockRows, lookupInstanceLabel, postEvent, postEvent, postFree, preFree, prePostAuditEvent, putProperty, putProperty, removeAllProperties, removeProperty, renderAsRandomAccessContent, renderAsReader, renderAsStream, setAttribute, setAttribute, setAttributes, setAttributes, setCopyContext, setFreeContext, setId, setName, setPropertyBundle, setPropertyValue, setUpdateContext, toString, trace, trustHandleCreate, trustHandleCreateAsAdmin, trustHandleFree, trustHandleFreeAsAdmin, trustHandleUpdate, trustHandleUpdateAsAdmin, update, updateAndExposeDefinition, validatePropertyValues, vectorLibraryObjectElement, vectorToLibraryObjectArray, verifyAdministrationMode, verifyConnected, verifySystemUserAccess, verifyTargetObject`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface oracle.ifs.common.LibraryObjectInterface
`getAttributeByUpperCaseName, getClassId, getId, getSessionInterface`

Methods inherited from interface oracle.ifs.common.Traceable
`getTraceLogger, isTraced, trace`

Field Detail

### CLASS_NAME

    public static final java.lang.String CLASS_NAME

  Description copied from class: `AccessControlEntry`
  This class name for this class. Useful for methods that take a class name argument.

  See Also:
    Constant Field Values
  (Published)

### ACL_ATTRIBUTE

    public static final java.lang.String ACL_ATTRIBUTE

  Description copied from class: `AccessControlEntry`
  The AccessControlList to which this AccessControlEntry belongs.

  See Also:
    Constant Field Values
  (Published)

### GRANTEE_ATTRIBUTE

    public static final java.lang.String GRANTEE_ATTRIBUTE

  Description copied from class: `AccessControlEntry`
  The DirectoryObject to which this AccessControlEntry is applied.

  See Also:
    Constant Field Values
  (Published)

### ACCESSLEVEL_ATTRIBUTE

    public static final java.lang.String ACCESSLEVEL_ATTRIBUTE

  Description copied from class: `AccessControlEntry`
  The level of the permission associated with this AccessControlEntry, e.g., Discover, Delete.

  See Also:
    Constant Field Values
  (Published)

### EXTENDEDPERMISSIONS_ATTRIBUTE

    public static final java.lang.String EXTENDEDPERMISSIONS_ATTRIBUTE

  Description copied from class: `AccessControlEntry`
  The extended permission levels created by a custom application which are associated with this AccessControlEntry.

  See Also:
    Constant Field Values
  (Published)

### GRANTED_ATTRIBUTE

    public static final java.lang.String GRANTED_ATTRIBUTE

  Description copied from class: `AccessControlEntry`
  An indicator of whether the AccessLevel is being granted or revoked by the AccessControlEntry.

  See Also:
    Constant Field Values
  (Published)

### SORTSEQUENCE_ATTRIBUTE

    public static final java.lang.String SORTSEQUENCE_ATTRIBUTE

  Description copied from class: `AccessControlEntry`
  The sort sequence of this AccessControlEntry in the AccessControlList.

  See Also:
    Constant Field Values
  (Published)

### PERMISSIONBUNDLES_ATTRIBUTE

    public static final java.lang.String PERMISSIONBUNDLES_ATTRIBUTE

  Description copied from class: `AccessControlEntry`
  The PermissionBundles optionally used to set the permissions for this AccessControlEntry.

  See Also:
    Constant Field Values
  (Published)

Constructor Detail

### AccessControlEntry

    protected AccessControlEntry(LibrarySession session,
                                 java.lang.Long id,
                                 java.lang.Long classId,
                                 S_LibraryObjectData data)
                          throws IfsException

  Construct a AccessControlEntry object.

  Parameters:
    `session` - current Session
    `id` - object ID
    `classId` - the class ID
    `data` - Data associated with the object.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

Method Detail

### getAcl

    public AccessControlList getAcl()
                             throws IfsException

  Description copied from class: `AccessControlEntry`
  Return the ACL object that contains this ACE.

  Returns:
    the ACL object that contains this ACE
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getGrantee

    public DirectoryObject getGrantee()
                               throws IfsException

  Description copied from class: `AccessControlEntry`
  Returns the directory object (grantee) that is associated with this ACE.

  Returns:
    the grantee for this ACE
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getDistinctAccessLevel

    public AccessLevel getDistinctAccessLevel()
                                       throws IfsException

  Description copied from class: `AccessControlEntry`
  Returns the access level represented by this ACE without considering permission bundles.

  Returns:
    the access level represented by this ACE.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getMergedAccessLevel

    public AccessLevel getMergedAccessLevel()
                                     throws IfsException

  Description copied from class: `AccessControlEntry`
  Returns the access level represented by this ACE including permission bundles.

  Returns:
    the access level represented by this ACE including permission bundles
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getExtendedPermissions

    public ExtendedPermission[] getExtendedPermissions()
                                                throws IfsException

  Description copied from class: `AccessControlEntry`
  Returns extended permissions of this ACE.

  Returns:
    an array of extended permissions.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getPermissionBundles

    public PermissionBundle[] getPermissionBundles()
                                            throws IfsException

  Description copied from class: `AccessControlEntry`
  Returns all PermissionBundles that were used to define the set of permissions for this ACE. If the permissions were set explicitly using access levels, returns null.

  Returns:
    array of permission bundles.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getSortSequence

    public long getSortSequence()
                         throws IfsException

  Description copied from class: `AccessControlEntry`
  Returns the Sort Sequence represented by this ACE. Sort sequnce determines the position of ACE within an ACL and used in determining the order of ACEs to evaluate effective permissions defined by an ACL.

  Returns:
    the sort sequence represented by this ACE.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### isGrant

    public boolean isGrant()
                    throws IfsException

  Description copied from class: `AccessControlEntry`
  Return indication as to whether this is a grant or a revoke ACE.

  Returns:
    true if this ACE represents a grant operation, or false otherwise
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### constructAccessControlEntryVector

    protected static java.util.Vector constructAccessControlEntryVector(LibrarySession sess,
                                                                        java.util.Vector vector)
                                                                 throws IfsException

  Description copied from class: `AccessControlEntry`
  Construct a Vector of ACE from a Vector of S_LibraryObjectData.

  Parameters:
    `sess` - the Session
    `vector` - a Vector of S_LibraryObjectData
  Returns:
    the Vector of AccessControlEntry objects.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### constructAccessControlEntry

    protected static AccessControlEntry constructAccessControlEntry(LibrarySession sess,
                                                                    S_LibraryObjectData data)
                                                             throws IfsException

  Description copied from class: `AccessControlEntry`
  Construct AccessControlEntry from a S_LibraryObjectData

  Parameters:
    `sess` - the Session
    `data` - the S_LibraryObejctData
  Returns:
    the ACE object
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### constructAccessControlEntryArray

    protected static AccessControlEntry[] constructAccessControlEntryArray(LibrarySession sess,
                                                                           java.lang.Long[] ids)
                                                                    throws IfsException

  Description copied from class: `AccessControlEntry`
  Construct a AccessControlEntry array from an array of object IDs. This will throw an exception if any of the IDs cannot be converted into a AccessControlentry object.

  Parameters:
    `sess` - the requesting session
    `ids` - the array of object IDs
  Returns:
    the array of ace's
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### vectorToAccessControlEntryArray

    protected static AccessControlEntry[] vectorToAccessControlEntryArray(java.util.Vector vector)

  Description copied from class: `AccessControlEntry`
  Convert a Vector of AccessControlEntrys to an array of AccessControlEntrys.

  Parameters:
    `vector` - A Vector containing AccessControlEntrys.
  Returns:
    an array of AccessControlEntrys.
  (Unpublished)

### vectorAccessControlEntryElement

    protected static AccessControlEntry vectorAccessControlEntryElement(java.util.Vector vector,
                                                                        int index)
                                                                 throws java.lang.IndexOutOfBoundsException

  Description copied from class: `AccessControlEntry`
  Return a AccessControlEntry from a specified Vector of AccessControlEntrys and an index.

  Parameters:
    `vector` - a Vector containing AccessControlEntrys.
    `index` - an index into the Vector of AccessControlEntrys.
  Returns:
    the requested AccessControlEntry.
  Throws:
    `java.lang.IndexOutOfBoundsException` - if index is invalid.
  (Unpublished)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD